import {select , json, geoPath, geoNaturalEarth1,tsv} from 'd3';
import {feature} from 'topojson';

const svg = select('svg');
const width = +svg.attr('width');
const height = +svg.attr('height');

// Set up instances 

const projection = geoNaturalEarth1();
const pathGenerator = geoPath().projection(projection); 

// set up path to eliminate background color to extra locations
svg.append('path')
		.attr('class','sphere')   // Created class of sphere so that we can style in css
		.attr('d',pathGenerator({type: 'Sphere'}));

// To add tooltips to the countries
Promise.all([ 
  tsv('https://unpkg.com/world-atlas@1.1.4/world/110m.tsv'),
	json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')
]).then(([tsvData , topoJSONdata]) => {

// created countryName object to retrieve countryname using iso_n3 from tsvData
  const countryName ={};
  tsvData.forEach(d => {
  countryName[d.iso_n3] = d.name;
  });
// parsing data  
  const countries = feature(topoJSONdata, topoJSONdata.objects.countries);
// Set up datajoin for paths
  svg.selectAll('path').data(countries.features)
    	.enter().append('path')
    			.attr('class', 'country')  // Created class of country
  				.attr('d', pathGenerator) // Append new path for each element
  			.append('title')
  		 .text(d => countryName[d.id]);
});







  